<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die();

class JElementJssectioncategoriesm9 extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;
		
		if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource') ){
	    	return '<b><a href="http://www.mightyextensions.com/joomla-components/resources-cck-custom-content-types">MightyResources</a> is not installed on your Joomla site</b>';
	    }

		$db =& JFactory::getDBO();

		$sql = "  SELECT s.id AS section_id, c.id AS cat_id, if(s.title <> '',s.title,s.name) AS section_title, if(c.title<>'',c.title, c.name) AS cat_title
		FROM #__js_res_category AS s
 		INNER JOIN #__js_res_category AS c ON (c.section_id = s.id OR c.id = s.id)";
		$sql_end =" AND c.published = 1 WHERE c.parent <> 0 AND s.parent = 0 AND s.published = 1 
 		ORDER BY (c.id = s.id) DESC, s.ordering, s.id, c.id, c.ordering";
		
		$result = '';
		
		if( !is_array($value))
	 		$value = array($value);
	
		if( $mainframe->isSite() ) {
			if (!empty($value) ) {
				$sql .= ' AND c.id IN('.implode(',',$value).') '.$sql_end ;
				$db->setQuery($sql);
				$result = $db->loadObjectList();
			}
		} else {
			$sql .= $sql_end;
			$db->setQuery($sql);
			$result = $db->loadObjectList();
		}

		$categories = array();
		$options = array();

		if( $result ) {
    		foreach( $result as $cat ){
    			$categories[$cat->section_title][$cat->cat_id] = $cat->cat_title;
    		}
		}

		foreach ($categories as $sec => $cats){
			$options [] = JHTML::_( 'select.optgroup', $sec );
			foreach ($cats as $key => $text) {
				$options [] = JHTML::_( 'select.option', $key, $text );
			}
		}
		
		$html = JHTML::_ ( 'select.genericlist', $options, "{$control_name}[{$name}][]", ' multiple size="6"', 'value', 'text', /*$mainframe->isSite () ? $ids : */$value );
		
		return $html;
	
	}
}
?>