<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die();

class JElementJsallcatsm10 extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;
		
		if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource') ){
	    	return '<b><a href="http://www.mightyextensions.com/joomla-components/resources-cck-custom-content-types">MightyResources</a> is not installed on your Joomla site</b>';
	    }

		$db	= &JFactory::getDBO();
		
		$multi = $node->attributes('multi');
		
		$sql = "    SELECT s.id as group_id, s.name as group_name, c.id as option_id, c.name as option_name"
		    ."\n      FROM #__js_res_category AS s"
		    ."\n INNER JOIN #__js_res_category AS c ON (c.section_id = s.id OR c.id = s.id) AND c.published = 1 ";
		    
		$sql_end = "\n     WHERE s.parent = 0 AND s.published = 1"
		    ."\n  ORDER BY c.name"
	 	;
	 	
	 	$result = '';
	 	
	 	if( !is_array($value) )
	 	    $value = array($value);
	 	
	 	if( $mainframe->isSite() ) {
			if (!empty($value) ) {
				$sql .= ' AND c.id IN('.implode(',',$value).') '.$sql_end ;
				$db->setQuery($sql);
				$result = $db->loadObjectList();
			}
		} else {
			$sql .= $sql_end;
			$db->setQuery($sql);
			$result = $db->loadObjectList();
		}
		
		$options = array();
		$option_list = array();
		
		if( $result ) {
    		foreach( $result as $option ){
    			$options[$option->group_id]['name'] = $option->group_name;
    			$options[$option->group_id]['options'][] = JHTML::_( 'select.option', $option->option_id, $option->option_name );
    		}
		}
		
		foreach( $options as $group_id => $option ) {
			$option_list[] = JHTML::_( 'select.optgroup', $option['name'] );
			$option_list = array_merge( $option_list, $option['options'] );
		}
		
		if( $multi ){
			$element_name = "{$control_name}[{$name}][]";
			$additional   = ' multiple="multiple" ';
		} else {
			$element_name = "{$control_name}[{$name}]";
			$additional   = '';
		}
		
		$html	= JHTML::_( 'select.genericlist',  $option_list, $element_name, ''.$additional, 'value', 'text', $value );
            
		return $html;
	}
}
?>