<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined ( '_JEXEC' ) or die ();

class JElementJsCriteria7 extends JElement {
	
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;
		
		$class = ( $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="inputbox"' );
		$multiple = ( $node->attributes('multiple') ? ' multiple="'.$node->attributes('multiple').'"' : '' );
		
		if( !is_array($value) ){
		    $value = array($value);
		}
		
		$options = array ();
		foreach ($node->children() as $option)
		{
			$val	= $option->attributes('value');
			if ( $mainframe->isSite()&& $value && !in_array($val, $value) ) 
				continue;
			$text	= $option->data();
			$options[] = JHTML::_('select.option', $val, JText::_($text));
		}

		return JHTML::_('select.genericlist',  $options, ''.$control_name.'['.$name. ($multiple ? '][]' : ']'), $class.$multiple, 'value', 'text', $value, $control_name.$name);
	}
	
}	