<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die();

class JElementJsSection6 extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;
		
		if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource') ){
	    	return '<b><a href="http://www.mightyextensions.com/joomla-components/resources-cck-custom-content-types">MightyResources</a> is not installed on your Joomla site</b>';
	    }
	    
		$db			=& JFactory::getDBO();
		$multi    = $node->attributes( 'multi', 0 );
		
		$sql = "SELECT id AS value, if(title != '', title, name) AS text FROM #__js_res_category WHERE published = 1 AND parent = 0";

		if( $mainframe->isSite() && empty($value) ) {
			$sections = array();
		} else {
			if ($mainframe->isSite())
				$sql .= ' AND id IN('.implode(',', (is_array($value) ? $value : array($value))).')';
			
			$db->setQuery($sql);
			$sections = $db->loadObjectList();
		}
		
		$options = array();
		foreach ($sections as $section)
		{
			$options[] = JHTML::_('select.option', $section->value, $section->text);
		}
		$multiselect = '';
		if($multi) $multiselect = 'size="'.count($sections).'" multiple';

		$html	= JHTML::_('select.genericlist',  $options,
            "{$control_name}[{$name}]".($multi ? "[]" : null), $multiselect, 'value', 'text', $value);

		return $html;
	}
}
?>
