<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined ( '_JEXEC' ) or die ();

class JElementJsSectionsWithCats extends JElement {
	
	function fetchElement($name, $value, &$node, $control_name) {
		
		global $mainframe;
		
		$is_juser_exist = is_dir ( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_resource' );
		if (! $is_juser_exist) {
			return '<b><a href="http://www.mightyextensions.com/joomla-components/resources-cck-custom-content-types">MightyResources</a> is not installed on your Joomla site</b>';
		}
		
		$name_values = 'articles';

		$db = & JFactory::getDBO ();
		
		if (! is_array ( $value ))
			$value = array ($value );
		
		if ( $mainframe->isSite() && !$value) {
			$cats = array();
		}else {
			$sql = "SELECT id, name, title, parent  
			FROM #__js_res_category 
			WHERE published = 1 " . ($mainframe->isSite() ? " AND section_id IN (" . implode ( ",", $value ) . ") OR id IN (" . implode ( ",", $value ) . ")" : " AND parent = 0 ")
			. " ORDER BY parent = 0 DESC, name ASC";
			
			$db->setQuery ( $sql );
			
			$cats = $db->loadObjectList ();
		}
		
		$sorted_cats = array ();
		
		$ids = array();
		if( $cats ){
			foreach ( $cats as $key => $cat ) {
				if ($cat->parent == 0) {
					$cat->level = 0;
					$sorted_cats [] = $cat;
					unset ( $cats [$key] );
				} else
					break;
			}
			while ( count ( $cats ) > 0 ) {
				foreach ( $cats as $key => $cat ) {
					foreach ( $sorted_cats as $skey => $sorted_cat ) {
						if ($cat->parent == $sorted_cat->id) {
							$cat->level = $sorted_cat->level + 1;
							while ( isset ( $sorted_cats [$skey + 1] ) && $sorted_cats [$skey + 1]->parent == $cat->parent )
								$skey ++;
							array_splice ( $sorted_cats, $skey, 1, array ($sorted_cats [$skey], $cat ) );
							unset ( $cats [$key] );
							break;
						}
					}
				}
			}
		}
		$options = array ();
		foreach ( $sorted_cats as $key => $cat ) {
			$ids[] = $cat->id;
			$prefix = str_repeat ( "&nbsp;&nbsp;-&nbsp;", $cat->level );
			$options [] = JHTML::_ ( 'select.option', $cat->id, ($cat->title ? $prefix . $cat->title : $prefix . $cat->name) );
		}
		
		$multiselect = 'size="' . count ( $sorted_cats ) . '" multiple ';
		$action = $mainframe->isSite() ? ' onChange="if ( check(this.getValue())>=0 ) xajax_jsCallAnalyticsPlugin(\'analytics\', \'resource20\', \'xajax_loadArticles\', {value: this.getValue(), id:\'params'.$name_values.'\',user:getUser()});" ' : '';
		
		$html = JHTML::_ ( 'select.genericlist', $options, "{$control_name}[{$name}][]", $multiselect . $action . ' size="6"', 'value', 'text', $mainframe->isSite () ? $ids : $value );
		
		if($mainframe->isSite())
		{
			$doc = &JFactory::getDocument();
			$doc->addScriptDeclaration("
			
			var available_ids = new Array(".implode(",",$ids).");
			
			function check(id){
				return available_ids.indexOf(parseInt(id));
			}
			
			function getUser(){
			
				if($('user_id')){
					return $('user_id').getValue();
				}else{
					return false;
				}
			}
			
			window.addEvent('domready', function(){
				xajax_jsCallAnalyticsPlugin('analytics', 'resource20', 'xajax_loadArticles', {value: $('".$control_name.$name."').getValue(), id:'params{$name_values}', user: getUser()});
			});
			
			");
		}
		
		return $html;
	}
}
?>
