<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined('_JEXEC') or die();

class JElementJsTypes extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;
		
	    if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource') ){
	    	return '<b><a href="http://www.mightyextensions.com/joomla-components/resources-cck-custom-content-types">MightyResources</a> is not installed on your Joomla site</b>';
	    }
		$db = &JFactory::getDBO();
		
		$sql = "Select id as value, name as text FROM #__js_res_types WHERE published = 1";
		
		$types = array();
		
		if( !$value )
		    $value = array();
		
		if ( !is_array($value) )
		    $value = array($value);
		
		if( $mainframe->isSite() ) {
			if (!empty($value) ) {
				$sql .= ' AND id in('.implode(',',$value).')';
				$db->setQuery($sql);
				$types = $db->loadObjectList();
			}
		}else {
			$db->setQuery($sql);
			$types = $db->loadObjectList();
		}
		
		if ( count($types) > 15){
			$size = 15;
		} else {
			$size = count($types);
		}
		$html = JHTML::_('select.genericlist',  $types, 
            "{$control_name}[{$name}][]", ' size="'.$size.'" multiple="multiple" ', 'value', 'text', $value);
            
		return $html;
	}
}