<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined('_JEXEC') or die();

class JElementJsrecordfields12 extends JElement
{
	function fetchElement($name, $value, &$node, $control_name)
	{
		global $mainframe;

		if( !is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource') ){
	    	return '<b><a href="http://www.mightyextensions.com/joomla-components/resources-cck-custom-content-types">MightyResources</a> is not installed on your Joomla site</b>';
	    }
		$name_values = 'field_values';

		$db	=& JFactory::getDBO();
		
		$sql = " SELECT t.id as type_id, t.name as type_name, f.id as field_id, f.title as field_name, f.type AS field_type"
		    ."\n FROM #__js_res_types AS t"
		    ."\n LEFT JOIN #__js_res_fields AS f ON f.type_id = t.id"
		    ."\n WHERE f.published = 1 AND f.type IN ( 'html', 'text', 'textarea')"
	 	;
	 	$result = '';
	 	
	 	if( !is_array($value))
	 		$value = array($value);
	
		if( $mainframe->isSite() ) {
			if (!empty($value) ) {
				$sql .= ' AND f.id IN('.implode(',',$value).')  ORDER BY t.id';
				$db->setQuery($sql);
				$result = $db->loadObjectList();
			}
		} else {
			$sql .= ' ORDER BY t.id';
			$db->setQuery($sql);
			$result = $db->loadObjectList();
		}
		
		$fields = array();
		$ids = array();
		$option_list = array();
		if( $result ) {
    		foreach( $result as $field ){
    			$fields[$field->type_id]['name'] = $field->type_name;
    			$fields[$field->type_id]['options'][] = JHTML::_( 'select.option', $field->field_id, $field->field_name.' ('.$field->field_type.')' );
    			$ids[] = $field->field_id;
    		}
		}
		foreach( $fields as $key => $field ) {
			$option_list[] = JHTML::_( 'select.optgroup', $fields[$key]['name'] );
			$option_list = array_merge( $option_list, $fields[$key]['options'] );
		}
		$html	= JHTML::_( 'select.genericlist',  $option_list, "{$control_name}[{$name}]".($mainframe->isAdmin() ? '[]' : ''), ($mainframe->isAdmin() ? 'multiple' : ''), 'value', 'text', $value );
           
		
		return $html;
	}
}
?>